#include "initialize.h"

using namespace std;

void read_parameters(struct st_parameters *param) {
	FILE   *fp;       // File pointer
	int    value;

	// Open parameter file
	fp = fopen(PARAMETERFILE,"r");
	if (fp == NULL) {
		cout << "Could not open parameter file" << endl;
		return;
	}

	// Read the parameter values
	value = fscanf(fp,"%d\n",&(param->nx));
	value = fscanf(fp,"%d\n",&(param->ny));
	value = fscanf(fp,"%d\n",&(param->t_max));
	value = fscanf(fp,"%d\n",&(param->save_param));
	value = fscanf(fp,"%f\n",&(param->density));
	value = fscanf(fp,"%f\n",&(param->accel));
	value = fscanf(fp,"%f\n",&(param->relax));
	value = fscanf(fp,"%d\n",&(param->reynolds_dim));

	// Close the file
	fclose(fp);

	param->omega = 1/param->relax;
}

void read_obstacles2(struct st_parameters param, vector<int> &obstacles) {
	FILE *fp;
	int x, y;
	int i;
    int sizeToAlloc = param.nx*param.ny;
	obstacles.resize(sizeToAlloc,0);

	// Open obstacle file
	fp = fopen(OBSTACLEFILE, "r");

	int retval;
	while ( (retval = fscanf(fp, "%d %d\n", &x, &y)) != EOF) {
		if (retval != 2) {
			cout << "Expected two values per line in obstacle file" << endl;			
			return;
		}
		if (x<0 || x>param.nx-1) {
			cout << "Obstacle X-Coord out of range" << endl;
			return;
		}
		if (y<0 || y>param.ny-1) {
			cout << "Obstacle Y-Coord out of range" << endl;
			return;
		}
		i = y*param.nx + x;
		obstacles[i] = 1;
	}
}
