#ifndef INITH
#define INITH 

#include <iostream>
#include <vector>
#include <amp.h>
#include <string>

#define PARAMETERFILE    "input.dat"
#define OBSTACLEFILE	 "obstacle.dat"
#define WRITEFOLDER		 "\\"
#define WRITEFILE		 "out.vtk"

struct st_parameters {
  int    nx;            // cells in y-direction
  int    ny;            // cells in x-direction
  int    t_max;			// number of iterations
  int	save_param;		// Number of saves
  float density;       // fluid density per link
  float accel;         // density redistribution
  float relax;			// relaxation time
  float omega;         // relaxation parameter
  int    reynolds_dim;  // linear dimension for Reynolds number
};

struct grid_cell1 {
	float sw;
	float s;
	float se;
};
struct grid_cell2 {
	float w;
	float c;
	float e;
};
struct grid_cell3 {
	float nw;
	float n;
	float ne;
};

void read_parameters(struct st_parameters *param);

void read_obstacles2(struct st_parameters param, std::vector<int> &obstacles);

void generate_grid(struct st_parameters param, std::vector<struct grid_cell> &node, std::vector<struct grid_cell> &tmp_node);
void generate_grid2(struct st_parameters param, struct grid_cell2 &node, struct grid_cell2 &tmp_node);

#endif