#include "main.h"
#include <ctime>
#include <amp.h>
#include <string>

using namespace std;
using namespace concurrency;

int main() {
	cout << "2D Lattice Boltzmann Method with C++ AMP" << endl;
	cout << "Kristoffer Thyholdt" << endl<< endl;

    struct st_parameters param;

	read_parameters(&param);

	cout << "Grid size: \t\t" << param.nx << "x" << param.ny << endl;
	cout << "Timesteps: \t\t" << param.t_max << endl;
	cout << "Relaxation Parameter: \t" << param.omega << endl;
	cout << "Fluid Density per link: " << param.density << endl;
	cout << "Density redistribution: " << param.accel << endl;
	cout << "Reynolds dimension: \t" << param.reynolds_dim << endl;

	cout << endl;
	int time_save = param.t_max/100;
	int out_save = 0;
	if (param.save_param != 0) {
		out_save = param.t_max/param.save_param;
	}

	timestep3(param, time_save, out_save);
	
    cin.get();
}

